*Imput missing data
*SPSS macros by Kirill Orlov
*kior@comtv.ru
*http://www.spsstools.net/KO-spssmacros.htm
*All rights reserved.

*/*!HDIMPUT*/***********************************************.
define !hdimput(var= !charend('/') /nmiss= !charend('/') /bgvars= !charend('/') /match= !charend('/') /samp= !charend('/'))
!let !ok= 1 !let !newvar= !conc('imput_',!var) !let !donor= !conc('donor_',!var) !let !vr= !conc(!var,'_fst#$#$') !let !bgvrs= !null !let !cnt= !null
!do !w !in (!bgvars) !let !cnt= !conc(!cnt,' ') !doend
!let !cnt= !len(!cnt)
!let !bgvrs= !conc('#1 to #',!cnt)
!if ((!len(!nmiss)=4 !and !nmiss>1000) !or !len(!nmiss)>4) !then !let !ok= 0
-echo '>ERROR. NMISS is not allowed more than 1000.'.
!ifend
!if ((!head(!match)='ANY' !or !head(!match)='HIE') !and !tail(!match)=!null) !then !let !ok= 0
-echo '>ERROR. Not specified numeric parameter after MATCH=ANY or MATCH=HIE.'.
!ifend
!if (!head(!match)='ALL' !and !tail(!match)<>!null) !then !let !ok= 0
-echo '>ERROR. MATCH=ALL needs no additional parameter after ALL.'.
!ifend
!if (!tail(!match)<>!null) !then !let !mtch= !head(!tail(!match))
 !if ((!len(!cnt)=!len(!mtch) !and !cnt<=!mtch) !or !len(!cnt)<!len(!mtch)) !then !let !ok= 0
- echo '>ERROR. Number by MATCH=ANY/HIE must be less than number of variables BGVARS.'.
 !else !let !cnt= !mtch
 !ifend
!ifend
!if (!ok) !then
-numer !newvar !donor (f8) case#$#$ break#$#$ nmatch#$#$ rand#$#$ notused#$#$ valid#$#$.
-apply dict from * /source var= !var /target var= !newvar.
-comp !newvar= !var.
-comp case#$#$= $casenum.
-comp notused#$#$= 1.
-comp rand#$#$= unif(1).
-comp valid#$#$= 1.
-aggr /outfile= * mode= addvari /break= valid#$#$ /filt#$#$= first(case#$#$).
-sort cases by filt#$#$ (d) !newvar rand#$#$ (a).
-do if not sysmis(filt#$#$) and sysmis(!newvar) and $casenum<=!nmiss.
- comp valid#$#$= 0.
- comp break#$#$= 1.
-else if sysmis(!newvar).
- comp break#$#$= 3.
-else.
- comp break#$#$= 2.
-end if.
 !do !i= 1 !to !nmiss
- comp nmatch#$#$= 0.
- comp #prev= 1.
- do rep v= !bgvars /#v= !bgvrs.
-  if $casenum=!i #v= v.
   !if (!head(!match)='HIE') !then
-   do if #prev and v=#v.
-    comp nmatch#$#$= nmatch#$#$+1.
-   else.
-    comp #prev= 0.
-   end if.
   !else
-   if v=#v nmatch#$#$= nmatch#$#$+1.
   !ifend
- end rep.
- comp rand#$#$= unif(1).
- do if break#$#$<>2.
-  recode nmatch#$#$ rand#$#$ (else=sysmis).
- end if.
- sort cases by break#$#$ (a) notused#$#$ nmatch#$#$ rand#$#$ (d).
- if break#$#$=2 and nmatch#$#$>=!cnt and notused#$#$ break#$#$= 1.
- if not sysmis(!newvar) cs#$#$= case#$#$.
- aggr /outfile= * mode= addvari overwrite= yes /break= break#$#$ /!vr= first(!newvar) /dcase#$#$= first(cs#$#$).
  !if (!samp<>'REPLACE') !then
-  if valid#$#$ and not lag(valid#$#$) and break#$#$=1 notused#$#$= 0.
  !ifend
- do if $casenum=!i and not valid#$#$.
-  comp !newvar= !vr.
-  comp !donor= dcase#$#$.
-  comp break#$#$= 0.
- else if valid#$#$ and break#$#$<>3.
-  comp break#$#$= 2.
- end if.
 !doend
-if sysmis(!newvar) !newvar= value(!var).
-if break#$#$=0 and miss(!newvar) !donor= 0.
-if break#$#$=3 !donor= -1.
-var lab !donor 'Donor case number which imputed this missing case'.
-val lab !donor 0 'Failed to be imputed' -1 'Did not undergo imputation'.
-var lev !donor (nom).
-sort cases by case#$#$.
-del vari case#$#$ break#$#$ nmatch#$#$ rand#$#$ notused#$#$ valid#$#$ cs#$#$ !vr dcase#$#$ filt#$#$.
!ifend
!enddefine.

*/*!HOTDECK*/***********************************************.
define !hotdeck(var= !charend('/') /bgvars= !charend('/') /samp= !charend('/'))
!let !newvar= !conc('imput_',!var) !let !donor= !conc('donor_',!var)
!if (!samp<>'REPLACE') !then
 !let !used= 'used1#$#$ used2#$#$ used3#$#$'
 !let !recused= 'recode used1#$#$ used2#$#$ used3#$#$ (else=0)'
 !let !compused1= 'comp used1#$#$= 1' !let !compused2= 'comp used2#$#$= 1' !let !compused3= 'comp used3#$#$= 1' 
 !let !notuseda= 'and not any(1,lag(used1#$#$,2),lag(used2#$#$,3),lag(used3#$#$,4))'
 !let !notusedb= 'and not any(1,lag(used1#$#$,3),lag(used2#$#$,4),lag(used3#$#$,5))'
 !let !notusedc= 'and not any(1,lag(used1#$#$,4),lag(used2#$#$,5),lag(used3#$#$,6))'
 !let !notusedd= 'and not any(1,lag(used2#$#$),lag(used3#$#$,2))'
 !let !notusede= 'and not any(1,lag(used3#$#$))'
!ifend
numer !newvar !donor (f8) case#$#$ rand#$#$ aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ !used.
apply dict from * /source var= !var /target var= !newvar.
comp !newvar= !var.
comp case#$#$= $casenum.
comp rand#$#$= unif(1).
recode aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ (else=1).
!recused.
sort cases by !bgvars rand#$#$.
set results none errors none.
!do !v !in (!bgvars)
-create leadbg1#$#$= lead(!v,1) /leadbg2#$#$= lead(!v,2) /leadbg3#$#$= lead(!v,3).
-do if miss(!v).
- recode aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ (else=0).
-else.
- if lag(!v)<>!v or miss(lag(!v)) aslag1#$#$= 0.
- if lag(!v,2)<>!v or miss(lag(!v,2)) aslag2#$#$= 0.
- if lag(!v,3)<>!v or miss(lag(!v,3)) aslag3#$#$= 0.
- if leadbg1#$#$<>!v or miss(leadbg1#$#$) aslead1#$#$= 0.
- if leadbg2#$#$<>!v or miss(leadbg2#$#$) aslead2#$#$= 0.
- if leadbg3#$#$<>!v or miss(leadbg3#$#$) aslead3#$#$= 0.
-end if.
!doend
create lead1#$#$= lead(!var,1) /lead2#$#$= lead(!var,2) /lead3#$#$= lead(!var,3)
      /case1#$#$= lead(case#$#$,1) /case2#$#$= lead(case#$#$,2) /case3#$#$= lead(case#$#$,3).
set results list errors list.
do if sysmis(!newvar).
-do if aslead1#$#$ and not miss(lead1#$#$) !notusedd.
- comp !newvar= lead1#$#$.
- comp !donor= case1#$#$.
- !compused1.
-else if aslead2#$#$ and not miss(lead2#$#$) !notusede.
- comp !newvar= lead2#$#$.
- comp !donor= case2#$#$.
- !compused2.
-else if aslead3#$#$ and not miss(lead3#$#$).
- comp !newvar= lead3#$#$.
- comp !donor= case3#$#$.
- !compused3.
-else if aslag1#$#$ and not miss(lag(!var)) !notuseda.
- comp !newvar= lag(!var).
- comp !donor= lag(case#$#$).
-else if aslag2#$#$ and not miss(lag(!var,2)) !notusedb.
- comp !newvar= lag(!var,2).
- comp !donor= lag(case#$#$,2).
-else if aslag3#$#$ and not miss(lag(!var,3)) !notusedc.
- comp !newvar= lag(!var,3).
- comp !donor= lag(case#$#$,3).
-end if.
end if.
if sysmis(!newvar) !newvar= value(!var).
do if miss(!var) and miss(!newvar).
-comp !donor= 0.
end if.
exec.
var lab !donor 'Donor case number which imputed this missing case'.
val lab !donor 0 'Failed to be imputed'.
var lev !donor (nom).
sort cases by case#$#$.
del vari case#$#$ rand#$#$ aslag1#$#$ aslag2#$#$ aslag3#$#$ aslead1#$#$ aslead2#$#$ aslead3#$#$ leadbg1#$#$ leadbg2#$#$ leadbg3#$#$ lead1#$#$ lead2#$#$ lead3#$#$ case1#$#$ case2#$#$ case3#$#$ !used.
!enddefine.

*/*!BORROW*/***********************************************.
define !borrow(vars= !charend('/') /donor= !charend('/') /ifrecval= !charend('/') /ifdonval= !charend('/') /cap= !charend('/'))
!let !fvars= !null !let !newvars= !null !let !cp= !unquote(!cap)
!do !w !in (!vars)
 !let !fvars= !conc(!fvars,' fst#$',!w) !let !newvars= !conc(!newvars,' ',!cp,!w)
!doend
!if (!ifrecval='ANY') !then !let !rec= 1 !ifend
!if (!ifrecval='MISSING' !or !ifrecval=!null) !then !let !rec= 'miss(var)' !ifend
!if (!ifrecval='SYSMIS') !then !let !rec= 'sysmis(var)' !ifend
!if (!ifrecval='VALID') !then !let !rec= 'not miss(var)' !ifend
!if (!ifrecval='BLANK') !then !let !rec= 'var=" "' !ifend
!if (!ifdonval='ANY') !then !let !don= 1 !ifend
!if (!ifdonval='MISSING') !then !let !don= 'miss(fvar)' !ifend
!if (!ifdonval='SYSMIS') !then !let !don= 'sysmis(fvar)' !ifend
!if (!ifdonval='VALID' !or !ifdonval=!null) !then !let !don= 'not miss(fvar)' !ifend
!if (!ifdonval='BLANK') !then !let !don= 'fvar=" "' !ifend
comp one#$#$= 1.
aggr /outfile= * mode= addvari /break= one#$#$ /ncas#$#$= nu.
dataset copy temp#$#$ window= hidden.
comp case#$#$= $casenum.
add files file= * /file= temp#$#$.
dataset close temp#$#$.
if not sysmis(case#$#$) !donor= case#$#$.
temp.
miss val !vars ().
set results none errors none.
recode !vars (sysmis=-999.195385798472).
aggr /outfile= * mode= addvari /break= !donor
     /!fvars= first(!vars).
!do !w !in (!vars)
-apply dict from= * /source var= !w
                    /target vari= !conc('fst#$',!w) !if (!cap<>!null) !then !conc(!cp,!w) !ifend
                    /newvar.
!doend
select if sysmis(case#$#$).
recode !fvars (-999.195385798472=sysmis).
set results list errors list.
recode !vars (else=copy) into !newvars.
do if range(!donor,1,ncas#$#$) and rnd(!donor)=!donor.
-do rep var= !vars /fvar= !fvars /newvar= !newvars.
- do if !rec and !don.
-  recode fvar (else=copy) into newvar.
- end if.
-end rep.
end if.
exec.
del vari case#$#$ one#$#$ ncas#$#$ !fvars.
!enddefine.
